## libglshim 0.1-maemo1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(glesgl)

# Raspberry PI
if(BCMHOST)
    include_directories(/opt/vc/include /opt/vc/include/interface/vcos/pthreads /opt/vc/include/interface/vmcs_host/linux)
    link_directories(/opt/vc/lib)
    add_definitions(-DBCMHOST)
endif()

link_directories(${CMAKE_BINARY_DIR}/lib)
add_definitions(-g -std=c99 -funwind-tables)

include_directories(include)
add_subdirectory(src)

=== spec/requirements.txt ===
jinja2
yaml

=== src/CMakeLists.txt ===
include_directories(util)

file(GLOB_RECURSE GL_SOURCES gl/*.c)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    include_directories(glx)
    aux_source_directory(glx GLX_SOURCES)
    list(APPEND GL_SOURCES ${GLX_SOURCES})
else()
    message(STATUS "Not on Linux: building without GLX support.")
endif()

add_library(GL SHARED ${GL_SOURCES})
target_link_libraries(GL EGL)

add_library(GL2 SHARED ${GL_SOURCES})
target_link_libraries(GL2 EGL)
SET_TARGET_PROPERTIES(GL2 PROPERTIES COMPILE_FLAGS -DUSE_ES2)

if(BCMHOST)
    set(PI_LIBS bcm_host vcos pthread)
    target_link_libraries(GL ${PI_LIBS} GLESv1_CM)
    target_link_libraries(GL2 ${PI_LIBS} GLESv2)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(GL X11)
    target_link_libraries(GL2 X11)
endif()

if(CMAKE_SHARED_LIBRARY_SUFFIX MATCHES ".so")
    set_target_properties(GL PROPERTIES SUFFIX ".so.1")
    set_target_properties(GL2 PROPERTIES SUFFIX ".so.1")
endif()

aux_source_directory(glu GLU_SOURCES)
add_library(GLU SHARED ${GLU_SOURCES})
target_link_libraries(GLU GL)

aux_source_directory(preload PRELOAD_SOURCES)
add_library(preload SHARED ${PRELOAD_SOURCES})
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    target_link_libraries(preload X11)
endif()

aux_source_directory(proxy PROXY_SOURCES)
add_library(proxy SHARED ${PROXY_SOURCES})

aux_source_directory(tests TEST_SOURCES)
add_executable(test ${TEST_SOURCES})
target_link_libraries(test proxy)

=== debian/changelog ===
libglshim (0.1-maemo1) unstable; urgency=low
	
  * Initial version

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sun, 04 Aug 2013 15:47:31 +0200

=== debian/control ===
Source: libglshim
Section: libs
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Build-Depends: debhelper (>> 5.0.0), cmake, libx11-dev, libgles1-sgx-img-dev [armel arm], libgles2-sgx-img-dev [armel arm]
Standards-Version: 3.7.2
XSBC-Bugtracker: mailto:aapo.rantalainen@gmail.com

Package: libglshim
Architecture: any
Replaces: libgl1
Provides: libgl1
Conflicts: libgl1
Depends: ${shlibs:Depends}
Description: GL to GLES

Package: libglshim-dev
Architecture: any
Depends: ${shlibs:Depends}, libglshim
Replaces: libgl1-dev
Provides: libgl1-dev
Conflicts: libgl1-dev
Description: GL to GLES

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess. 

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -O0
else
	CPPFLAGS += -O3
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -g -O0 -DDEBUG
else
	CPPFLAGS += -DNDEBUG
endif



config.status: configure
	dh_testdir
	# Add here commands to configure the package.

configure:

build: build-stamp
build-stamp: config.status
	dh_testdir

	# Add here commands to compile the package.
ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
	mkdir build ; cd build ; cmake .. ; make GL 
endif

	touch build-stamp

clean: config.status
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	rm -rf build

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/<packagename>
	#$(MAKE) DESTDIR=`pwd`/debian/`dh_listpackages` install
	#!/bin/sh
	CURDIR=$1

ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
	mkdir -p ${CURDIR}/debian/libglshim-dev/usr/include/
	cp -r include/GL ${CURDIR}/debian/libglshim-dev/usr/include/

	mkdir -p ${CURDIR}/debian/libglshim/usr/lib
	cp ${CURDIR}/build/src/libGL.so.1  ${CURDIR}/debian/libglshim/usr/lib/
	ln -s libGL.so.1 ${CURDIR}/debian/libglshim/usr/lib/libGL.so
endif


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installchangelogs
#	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installwm
#	dh_installudev
#	dh_undocumented
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## libglshim 0.1-maemo2

=== debian/changelog ===
libglshim (0.1-maemo2) unstable; urgency=low
	
  *Add: dh_makeshlibs

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Mon, 05 Aug 2013 21:34:31 +0200

=== debian/rules ===
--- 
+++ 
@@ -108,7 +108,7 @@
 	dh_fixperms
 #	dh_perl
 #	dh_python
-#	dh_makeshlibs
+	dh_makeshlibs
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

## libglshim 0.1-maemo3

=== debian/changelog ===
libglshim (0.1-maemo3) unstable; urgency=low

  * Can be used with freeglut3 / freeglut3-dev
   -libglshim provides libgl1
   -libglsim-dev provies libgl-dev

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 06 Aug 2013 13:23:31 +0200

=== debian/control ===
--- 
+++ 
@@ -17,8 +17,8 @@
 Package: libglshim-dev
 Architecture: any
 Depends: ${shlibs:Depends}, libglshim
-Replaces: libgl1-dev
-Provides: libgl1-dev
-Conflicts: libgl1-dev
+Replaces: libgl-dev
+Provides: libgl-dev
+Conflicts: libgl-dev
 Description: GL to GLES

## libglshim 0.1-maemo4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,12 @@
 
 add_library(GL SHARED ${GL_SOURCES})
 target_link_libraries(GL EGL)
+add_library(GL_static STATIC ${GL_SOURCES})
+set_target_properties(GL_static PROPERTIES OUTPUT_NAME GL)
 
-add_library(GL2 SHARED ${GL_SOURCES})
+add_library(GL2 SHARED EXCLUDE_FROM_ALL ${GL_SOURCES})
 target_link_libraries(GL2 EGL)
-SET_TARGET_PROPERTIES(GL2 PROPERTIES COMPILE_FLAGS -DUSE_ES2)
+set_target_properties(GL2 PROPERTIES COMPILE_FLAGS -DUSE_ES2)
 
 if(BCMHOST)
     set(PI_LIBS bcm_host vcos pthread)
@@ -33,19 +35,10 @@
     set_target_properties(GL2 PROPERTIES SUFFIX ".so.1")
 endif()
 
-aux_source_directory(glu GLU_SOURCES)
-add_library(GLU SHARED ${GLU_SOURCES})
-target_link_libraries(GLU GL)
-
 aux_source_directory(preload PRELOAD_SOURCES)
 add_library(preload SHARED ${PRELOAD_SOURCES})
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
     target_link_libraries(preload X11)
 endif()
 
-aux_source_directory(proxy PROXY_SOURCES)
-add_library(proxy SHARED ${PROXY_SOURCES})
-
-aux_source_directory(tests TEST_SOURCES)
-add_executable(test ${TEST_SOURCES})
-target_link_libraries(test proxy)
+add_subdirectory(proxy)

=== debian/changelog ===
libglshim (0.1-maemo4) unstable; urgency=low

  * New code from https://github.com/lunixbochs/glshim
  * Add: libglshim depends libgles1 (always really depended, but missed from list)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 23 Jan 2014 20:39:31 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Replaces: libgl1
 Provides: libgl1
 Conflicts: libgl1
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, libgles1
 Description: GL to GLES
 
 Package: libglshim-dev

=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,7 @@
 config.status: configure
 	dh_testdir
 	# Add here commands to configure the package.
-
+	touch config.status
 configure:
 
 build: build-stamp
@@ -47,7 +47,8 @@
 
 	touch build-stamp
 
-clean: config.status
+#clean: config.status
+clean:
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp
@@ -71,13 +72,13 @@
 	cp -r include/GL ${CURDIR}/debian/libglshim-dev/usr/include/
 
 	mkdir -p ${CURDIR}/debian/libglshim/usr/lib
-	cp ${CURDIR}/build/src/libGL.so.1  ${CURDIR}/debian/libglshim/usr/lib/
+	cp ${CURDIR}/build/lib/libGL.so.1  ${CURDIR}/debian/libglshim/usr/lib/
 	ln -s libGL.so.1 ${CURDIR}/debian/libglshim/usr/lib/libGL.so
 endif
 
 
 # Build architecture-independent files here.
-binary-indep: build install
+# binary-indep: build install
 # We have nothing to do by default.
 
 # Build architecture-dependent files here.
@@ -115,5 +116,5 @@
 	dh_md5sums
 	dh_builddeb
 
-binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install
+binary: binary-arch
+.PHONY: build clean binary-arch binary install
